<?php

namespace SuperRhino\Utils\SubTable;

interface SubTableInterface {

    /**
     * 分表数量 默认32
     * @return int
     */
    public static function subTableCount(): int;

    /**
     * 表名 默认使用table表名做前缀
     * @return string
     */
    public static function subTableName(): string;

    /**
     * 分表后缀记录表名 默认使用表名按照规则生成, 可以自己指定
     * @return string
     */
    public static function getSuffixRecordTableName(): string;

    /**
     * 分表后缀缓存key
     * @param mixed $key
     * @return string
     */
    public static function subTableSuffixCacheKey($key): string;

    /**
     * 分表后缀缓存时间 默认1小时
     * @return int
     */
    public static function subTableSuffixCacheTimeout(): int;

    /**
     * 分表后缀列表
     * @return string[]
     */
    public static function getSubTableSuffixList(): array;

    /**
     * 分表字符串后缀
     * @param $key
     * @param bool $isCache
     * @return string
     */
    public static function getSubTableSuffix($key, bool $isCache = true): string;

    /**
     * 创建表前缀记录表
     */
    public static function suffixRecordTableUp();

    /**
     * 删除表前缀记录表
     */
    public static function suffixRecordTableDown();
}